=== debian/changelog ===
opus (1.6.1-1) unstable; urgency=medium

  * New upstream version 1.6.1

  * Update git repository layout to follow DEP-14
  * Modernize d/watch file to version 5

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 29 Jan 2026 15:35:32 +0100
